<HTML>
<HEAD>
  <META NAME="GENERATOR" CONTENT="Adobe PageMill 3.0 Win">
  <TITLE>Ambient source language</TITLE>
</HEAD>
<BODY BGCOLOR="#ffffff">

<H1>Ambient Source Language</H1>

<P>The source language is an extension of Caml, with the usual
syntax for types, modules, and expressions. The syntax extension
include the ambient operations:</P>

<H3>Additional modules</H3>

<UL>
  <LI><B><TT>ambient</TT></B><TT> Name : module_type<BR>
<BR>
  </TT>Declares an ambient with the fields given in the module
  type<BR>
  <LI><B><TT>ambient</TT></B><TT> Name = <B>struct</B><BR>
  &nbsp;&nbsp;&nbsp;&nbsp;</TT><I>module items<BR>
  </I><B><TT>end</TT></B><BR>
<BR>
  Defines a new ambient. The definition is the same as for a module,
  and the fields can be accessed just as they would be in a module.
</UL>

<H3>Additional expressions</H3>

<UL>
  <LI>Actions: <TT>(<B>in</B> Name)</TT>, <TT>(<B>out</B> Name)</TT>,
  <TT>(<B>open</B> Name)</TT>: these actions can be performed using
  the <B><TT>migrate</TT> </B>expression. The <B><TT>in</TT></B>
  message move the current ambient into the named module, the <B><TT>out</TT></B>
  message moves the module out of the parent module <TT>Name</TT>,
  and the <B><TT>open</TT> </B>message opens a module with name
  <TT>Name</TT> in the current folder.
  <LI><B><TT><FONT SIZE="+1">action</FONT></TT></B><TT><FONT SIZE="+1">
  e1; ...; en</FONT></TT><FONT SIZE="+1">: </FONT>composes the
  messages.
  <LI><B><TT>migrate</TT></B><TT> e1 -&gt; e2</TT>: performes the
  actions defined by <TT>e1</TT>, then evaluates expression <TT>e2</TT>.
  <LI><B><TT>thread</TT></B><TT> e</TT>: create a new thread that
  evaluates the expression <TT>e</TT>. The <B><TT>thread</TT></B>
  operation returns the unit expression <TT>()</TT> immediately.
</UL>

</BODY>
</HTML>
